submodule: add newline on invalid submodule error
[git.git] / git-submodule.sh
blob58713c5467f02dd79efefd4534373757af81713e
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
11 or: $dashless [--quiet] init [--] [<path>...]
12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
14 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
15 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
16 or: $dashless [--quiet] foreach [--recursive] <command>
17 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
18 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
19 OPTIONS_SPEC=
20 SUBDIRECTORY_OK=Yes
21 . git-sh-setup
22 . git-parse-remote
23 require_work_tree
24 wt_prefix=$(git rev-parse --show-prefix)
25 cd_to_toplevel
27 # Tell the rest of git that any URLs we get don't come
28 # directly from the user, so it can apply policy as appropriate.
29 GIT_PROTOCOL_FROM_USER=0
30 export GIT_PROTOCOL_FROM_USER
32 command=
33 branch=
34 force=
35 reference=
36 cached=
37 recursive=
38 init=
39 require_init=
40 files=
41 remote=
42 nofetch=
43 update=
44 prefix=
45 custom_name=
46 depth=
47 progress=
48 dissociate=
50 die_if_unmatched ()
52 if test "$1" = "#unmatched"
53 then
54 exit ${2:-1}
59 # Print a submodule configuration setting
61 # $1 = submodule name
62 # $2 = option name
63 # $3 = default value
65 # Checks in the usual git-config places first (for overrides),
66 # otherwise it falls back on .gitmodules. This allows you to
67 # distribute project-wide defaults in .gitmodules, while still
68 # customizing individual repositories if necessary. If the option is
69 # not in .gitmodules either, print a default value.
71 get_submodule_config () {
72 name="$1"
73 option="$2"
74 default="$3"
75 value=$(git config submodule."$name"."$option")
76 if test -z "$value"
77 then
78 value=$(git submodule--helper config submodule."$name"."$option")
80 printf '%s' "${value:-$default}"
83 isnumber()
85 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
88 # Given a full hex object ID, is this the zero OID?
89 is_zero_oid () {
90 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
93 # Sanitize the local git environment for use within a submodule. We
94 # can't simply use clear_local_git_env since we want to preserve some
95 # of the settings from GIT_CONFIG_PARAMETERS.
96 sanitize_submodule_env()
98 save_config=$GIT_CONFIG_PARAMETERS
99 clear_local_git_env
100 GIT_CONFIG_PARAMETERS=$save_config
101 export GIT_CONFIG_PARAMETERS
105 # Add a new submodule to the working tree, .gitmodules and the index
107 # $@ = repo path
109 # optional branch is stored in global branch variable
111 cmd_add()
113 # parse $args after "submodule ... add".
114 reference_path=
115 while test $# -ne 0
117 case "$1" in
118 -b | --branch)
119 case "$2" in '') usage ;; esac
120 branch=$2
121 shift
123 -f | --force)
124 force=$1
126 -q|--quiet)
127 GIT_QUIET=1
129 --progress)
130 progress=1
132 --reference)
133 case "$2" in '') usage ;; esac
134 reference_path=$2
135 shift
137 --reference=*)
138 reference_path="${1#--reference=}"
140 --dissociate)
141 dissociate=1
143 --name)
144 case "$2" in '') usage ;; esac
145 custom_name=$2
146 shift
148 --depth)
149 case "$2" in '') usage ;; esac
150 depth="--depth=$2"
151 shift
153 --depth=*)
154 depth=$1
157 shift
158 break
161 usage
164 break
166 esac
167 shift
168 done
170 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
171 then
172 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
175 if test -n "$reference_path"
176 then
177 is_absolute_path "$reference_path" ||
178 reference_path="$wt_prefix$reference_path"
180 reference="--reference=$reference_path"
183 repo=$1
184 sm_path=$2
186 if test -z "$sm_path"; then
187 sm_path=$(printf '%s\n' "$repo" |
188 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
191 if test -z "$repo" || test -z "$sm_path"; then
192 usage
195 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
197 # assure repo is absolute or relative to parent
198 case "$repo" in
199 ./*|../*)
200 test -z "$wt_prefix" ||
201 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
203 # dereference source url relative to parent's url
204 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
206 *:*|/*)
207 # absolute url
208 realrepo=$repo
211 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
213 esac
215 # normalize path:
216 # multiple //; leading ./; /./; /../; trailing /
217 sm_path=$(printf '%s/\n' "$sm_path" |
218 sed -e '
219 s|//*|/|g
220 s|^\(\./\)*||
221 s|/\(\./\)*|/|g
222 :start
223 s|\([^/]*\)/\.\./||
224 tstart
225 s|/*$||
227 if test -z "$force"
228 then
229 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
230 die "$(eval_gettext "'\$sm_path' already exists in the index")"
231 else
232 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
233 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
236 if test -d "$sm_path" &&
237 test -z $(git -C "$sm_path" rev-parse --show-cdup 2>/dev/null)
238 then
239 git -C "$sm_path" rev-parse --verify -q HEAD >/dev/null ||
240 die "$(eval_gettext "'\$sm_path' does not have a commit checked out")"
243 if test -z "$force" &&
244 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
245 then
246 eval_gettextln "The following path is ignored by one of your .gitignore files:
247 \$sm_path
248 Use -f if you really want to add it." >&2
249 exit 1
252 if test -n "$custom_name"
253 then
254 sm_name="$custom_name"
255 else
256 sm_name="$sm_path"
259 if ! git submodule--helper check-name "$sm_name"
260 then
261 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
264 # perhaps the path exists and is already a git repo, else clone it
265 if test -e "$sm_path"
266 then
267 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
268 then
269 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
270 else
271 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
274 else
275 if test -d ".git/modules/$sm_name"
276 then
277 if test -z "$force"
278 then
279 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
280 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
281 die "$(eval_gettextln "\
282 If you want to reuse this local git directory instead of cloning again from
283 \$realrepo
284 use the '--force' option. If the local git directory is not the correct repo
285 or you are unsure what this means choose another name with the '--name' option.")"
286 else
287 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
290 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
292 sanitize_submodule_env
293 cd "$sm_path" &&
294 # ash fails to wordsplit ${branch:+-b "$branch"...}
295 case "$branch" in
296 '') git checkout -f -q ;;
297 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
298 esac
299 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
301 git config submodule."$sm_name".url "$realrepo"
303 git add --no-warn-embedded-repo $force "$sm_path" ||
304 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
306 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
307 git submodule--helper config submodule."$sm_name".url "$repo" &&
308 if test -n "$branch"
309 then
310 git submodule--helper config submodule."$sm_name".branch "$branch"
311 fi &&
312 git add --force .gitmodules ||
313 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
315 # NEEDSWORK: In a multi-working-tree world, this needs to be
316 # set in the per-worktree config.
317 if git config --get submodule.active >/dev/null
318 then
319 # If the submodule being adding isn't already covered by the
320 # current configured pathspec, set the submodule's active flag
321 if ! git submodule--helper is-active "$sm_path"
322 then
323 git config submodule."$sm_name".active "true"
325 else
326 git config submodule."$sm_name".active "true"
331 # Execute an arbitrary command sequence in each checked out
332 # submodule
334 # $@ = command to execute
336 cmd_foreach()
338 # parse $args after "submodule ... foreach".
339 while test $# -ne 0
341 case "$1" in
342 -q|--quiet)
343 GIT_QUIET=1
345 --recursive)
346 recursive=1
349 usage
352 break
354 esac
355 shift
356 done
358 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
362 # Register submodules in .git/config
364 # $@ = requested paths (default to all)
366 cmd_init()
368 # parse $args after "submodule ... init".
369 while test $# -ne 0
371 case "$1" in
372 -q|--quiet)
373 GIT_QUIET=1
376 shift
377 break
380 usage
383 break
385 esac
386 shift
387 done
389 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
393 # Unregister submodules from .git/config and remove their work tree
395 cmd_deinit()
397 # parse $args after "submodule ... deinit".
398 deinit_all=
399 while test $# -ne 0
401 case "$1" in
402 -f|--force)
403 force=$1
405 -q|--quiet)
406 GIT_QUIET=1
408 --all)
409 deinit_all=t
412 shift
413 break
416 usage
419 break
421 esac
422 shift
423 done
425 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
428 is_tip_reachable () (
429 sanitize_submodule_env &&
430 cd "$1" &&
431 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
432 test -z "$rev"
435 fetch_in_submodule () (
436 sanitize_submodule_env &&
437 cd "$1" &&
438 case "$2" in
440 git fetch ;;
442 shift
443 git fetch $(get_default_remote) "$@" ;;
444 esac
448 # Update each submodule path to correct revision, using clone and checkout as needed
450 # $@ = requested paths (default to all)
452 cmd_update()
454 # parse $args after "submodule ... update".
455 while test $# -ne 0
457 case "$1" in
458 -q|--quiet)
459 GIT_QUIET=1
462 GIT_QUIET=0
464 --progress)
465 progress=1
467 -i|--init)
468 init=1
470 --require-init)
471 init=1
472 require_init=1
474 --remote)
475 remote=1
477 -N|--no-fetch)
478 nofetch=1
480 -f|--force)
481 force=$1
483 -r|--rebase)
484 update="rebase"
486 --reference)
487 case "$2" in '') usage ;; esac
488 reference="--reference=$2"
489 shift
491 --reference=*)
492 reference="$1"
494 --dissociate)
495 dissociate=1
497 -m|--merge)
498 update="merge"
500 --recursive)
501 recursive=1
503 --checkout)
504 update="checkout"
506 --recommend-shallow)
507 recommend_shallow="--recommend-shallow"
509 --no-recommend-shallow)
510 recommend_shallow="--no-recommend-shallow"
512 --depth)
513 case "$2" in '') usage ;; esac
514 depth="--depth=$2"
515 shift
517 --depth=*)
518 depth=$1
520 -j|--jobs)
521 case "$2" in '') usage ;; esac
522 jobs="--jobs=$2"
523 shift
525 --jobs=*)
526 jobs=$1
529 shift
530 break
533 usage
536 break
538 esac
539 shift
540 done
542 if test -n "$init"
543 then
544 cmd_init "--" "$@" || return
548 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
549 ${progress:+"--progress"} \
550 ${wt_prefix:+--prefix "$wt_prefix"} \
551 ${prefix:+--recursive-prefix "$prefix"} \
552 ${update:+--update "$update"} \
553 ${reference:+"$reference"} \
554 ${dissociate:+"--dissociate"} \
555 ${depth:+--depth "$depth"} \
556 ${require_init:+--require-init} \
557 $recommend_shallow \
558 $jobs \
559 -- \
560 "$@" || echo "#unmatched" $?
561 } | {
562 err=
563 while read -r quickabort sha1 just_cloned sm_path
565 die_if_unmatched "$quickabort" "$sha1"
567 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
569 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
571 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
573 if test $just_cloned -eq 1
574 then
575 subsha1=
576 else
577 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
578 git rev-parse --verify HEAD) ||
579 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
582 if test -n "$remote"
583 then
584 branch=$(git submodule--helper remote-branch "$sm_path")
585 if test -z "$nofetch"
586 then
587 # Fetch remote before determining tracking $sha1
588 fetch_in_submodule "$sm_path" $depth ||
589 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
591 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
592 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
593 git rev-parse --verify "${remote_name}/${branch}") ||
594 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
597 if test "$subsha1" != "$sha1" || test -n "$force"
598 then
599 subforce=$force
600 # If we don't already have a -f flag and the submodule has never been checked out
601 if test -z "$subsha1" && test -z "$force"
602 then
603 subforce="-f"
606 if test -z "$nofetch"
607 then
608 # Run fetch only if $sha1 isn't present or it
609 # is not reachable from a ref.
610 is_tip_reachable "$sm_path" "$sha1" ||
611 fetch_in_submodule "$sm_path" $depth ||
612 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
614 # Now we tried the usual fetch, but $sha1 may
615 # not be reachable from any of the refs
616 is_tip_reachable "$sm_path" "$sha1" ||
617 fetch_in_submodule "$sm_path" $depth "$sha1" ||
618 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
621 must_die_on_failure=
622 case "$update_module" in
623 checkout)
624 command="git checkout $subforce -q"
625 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
626 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
628 rebase)
629 command="git rebase"
630 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
631 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
632 must_die_on_failure=yes
634 merge)
635 command="git merge"
636 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
637 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
638 must_die_on_failure=yes
641 command="${update_module#!}"
642 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
643 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
644 must_die_on_failure=yes
647 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
648 esac
650 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
651 then
652 say "$say_msg"
653 elif test -n "$must_die_on_failure"
654 then
655 die_with_status 2 "$die_msg"
656 else
657 err="${err};$die_msg"
658 continue
662 if test -n "$recursive"
663 then
665 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
666 wt_prefix=
667 sanitize_submodule_env
668 cd "$sm_path" &&
669 eval cmd_update
671 res=$?
672 if test $res -gt 0
673 then
674 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
675 if test $res -ne 2
676 then
677 err="${err};$die_msg"
678 continue
679 else
680 die_with_status $res "$die_msg"
684 done
686 if test -n "$err"
687 then
688 OIFS=$IFS
689 IFS=';'
690 for e in $err
692 if test -n "$e"
693 then
694 echo >&2 "$e"
696 done
697 IFS=$OIFS
698 exit 1
704 # Configures a submodule's default branch
706 # $@ = requested path
708 cmd_set_branch() {
709 unset_branch=false
710 branch=
712 while test $# -ne 0
714 case "$1" in
715 -q|--quiet)
716 # we don't do anything with this but we need to accept it
718 -d|--default)
719 unset_branch=true
721 -b|--branch)
722 case "$2" in '') usage ;; esac
723 branch=$2
724 shift
727 shift
728 break
731 usage
734 break
736 esac
737 shift
738 done
740 if test $# -ne 1
741 then
742 usage
745 # we can't use `git submodule--helper name` here because internally, it
746 # hashes the path so a trailing slash could lead to an unintentional no match
747 name="$(git submodule--helper list "$1" | cut -f2)"
748 if test -z "$name"
749 then
750 exit 1
753 test -n "$branch"; has_branch=$?
754 test "$unset_branch" = true; has_unset_branch=$?
756 if test $((!$has_branch != !$has_unset_branch)) -eq 0
757 then
758 usage
761 if test $has_branch -eq 0
762 then
763 git submodule--helper config submodule."$name".branch "$branch"
764 else
765 git submodule--helper config --unset submodule."$name".branch
770 # Show commit summary for submodules in index or working tree
772 # If '--cached' is given, show summary between index and given commit,
773 # or between working tree and given commit
775 # $@ = [commit (default 'HEAD'),] requested paths (default all)
777 cmd_summary() {
778 summary_limit=-1
779 for_status=
780 diff_cmd=diff-index
782 # parse $args after "submodule ... summary".
783 while test $# -ne 0
785 case "$1" in
786 --cached)
787 cached="$1"
789 --files)
790 files="$1"
792 --for-status)
793 for_status="$1"
795 -n|--summary-limit)
796 summary_limit="$2"
797 isnumber "$summary_limit" || usage
798 shift
800 --summary-limit=*)
801 summary_limit="${1#--summary-limit=}"
802 isnumber "$summary_limit" || usage
805 shift
806 break
809 usage
812 break
814 esac
815 shift
816 done
818 test $summary_limit = 0 && return
820 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
821 then
822 head=$rev
823 test $# = 0 || shift
824 elif test -z "$1" || test "$1" = "HEAD"
825 then
826 # before the first commit: compare with an empty tree
827 head=$(git hash-object -w -t tree --stdin </dev/null)
828 test -z "$1" || shift
829 else
830 head="HEAD"
833 if [ -n "$files" ]
834 then
835 test -n "$cached" &&
836 die "$(gettext "The --cached option cannot be used with the --files option")"
837 diff_cmd=diff-files
838 head=
841 cd_to_toplevel
842 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
843 # Get modified modules cared by user
844 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
845 sane_egrep '^:([0-7]* )?160000' |
846 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
848 # Always show modules deleted or type-changed (blob<->module)
849 if test "$status" = D || test "$status" = T
850 then
851 printf '%s\n' "$sm_path"
852 continue
854 # Respect the ignore setting for --for-status.
855 if test -n "$for_status"
856 then
857 name=$(git submodule--helper name "$sm_path")
858 ignore_config=$(get_submodule_config "$name" ignore none)
859 test $status != A && test $ignore_config = all && continue
861 # Also show added or modified modules which are checked out
862 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
863 printf '%s\n' "$sm_path"
864 done
867 test -z "$modules" && return
869 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
870 sane_egrep '^:([0-7]* )?160000' |
871 cut -c2- |
872 while read -r mod_src mod_dst sha1_src sha1_dst status name
874 if test -z "$cached" &&
875 is_zero_oid $sha1_dst
876 then
877 case "$mod_dst" in
878 160000)
879 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
881 100644 | 100755 | 120000)
882 sha1_dst=$(git hash-object $name)
884 000000)
885 ;; # removed
887 # unexpected type
888 eval_gettextln "unexpected mode \$mod_dst" >&2
889 continue ;;
890 esac
892 missing_src=
893 missing_dst=
895 test $mod_src = 160000 &&
896 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
897 missing_src=t
899 test $mod_dst = 160000 &&
900 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
901 missing_dst=t
903 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
905 total_commits=
906 case "$missing_src,$missing_dst" in
908 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
911 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
913 t,t)
914 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
917 errmsg=
918 total_commits=$(
919 if test $mod_src = 160000 && test $mod_dst = 160000
920 then
921 range="$sha1_src...$sha1_dst"
922 elif test $mod_src = 160000
923 then
924 range=$sha1_src
925 else
926 range=$sha1_dst
928 GIT_DIR="$name/.git" \
929 git rev-list --first-parent $range -- | wc -l
931 total_commits=" ($(($total_commits + 0)))"
933 esac
935 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
936 echo $sha1_src | cut -c1-7)
937 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
938 echo $sha1_dst | cut -c1-7)
940 if test $status = T
941 then
942 blob="$(gettext "blob")"
943 submodule="$(gettext "submodule")"
944 if test $mod_dst = 160000
945 then
946 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
947 else
948 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
950 else
951 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
953 if test -n "$errmsg"
954 then
955 # Don't give error msg for modification whose dst is not submodule
956 # i.e. deleted or changed to blob
957 test $mod_dst = 160000 && echo "$errmsg"
958 else
959 if test $mod_src = 160000 && test $mod_dst = 160000
960 then
961 limit=
962 test $summary_limit -gt 0 && limit="-$summary_limit"
963 GIT_DIR="$name/.git" \
964 git log $limit --pretty='format: %m %s' \
965 --first-parent $sha1_src...$sha1_dst
966 elif test $mod_dst = 160000
967 then
968 GIT_DIR="$name/.git" \
969 git log --pretty='format: > %s' -1 $sha1_dst
970 else
971 GIT_DIR="$name/.git" \
972 git log --pretty='format: < %s' -1 $sha1_src
974 echo
976 echo
977 done
980 # List all submodules, prefixed with:
981 # - submodule not initialized
982 # + different revision checked out
984 # If --cached was specified the revision in the index will be printed
985 # instead of the currently checked out revision.
987 # $@ = requested paths (default to all)
989 cmd_status()
991 # parse $args after "submodule ... status".
992 while test $# -ne 0
994 case "$1" in
995 -q|--quiet)
996 GIT_QUIET=1
998 --cached)
999 cached=1
1001 --recursive)
1002 recursive=1
1005 shift
1006 break
1009 usage
1012 break
1014 esac
1015 shift
1016 done
1018 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
1021 # Sync remote urls for submodules
1022 # This makes the value for remote.$remote.url match the value
1023 # specified in .gitmodules.
1025 cmd_sync()
1027 while test $# -ne 0
1029 case "$1" in
1030 -q|--quiet)
1031 GIT_QUIET=1
1032 shift
1034 --recursive)
1035 recursive=1
1036 shift
1039 shift
1040 break
1043 usage
1046 break
1048 esac
1049 done
1051 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
1054 cmd_absorbgitdirs()
1056 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1059 # This loop parses the command line arguments to find the
1060 # subcommand name to dispatch. Parsing of the subcommand specific
1061 # options are primarily done by the subcommand implementations.
1062 # Subcommand specific options such as --branch and --cached are
1063 # parsed here as well, for backward compatibility.
1065 while test $# != 0 && test -z "$command"
1067 case "$1" in
1068 add | foreach | init | deinit | update | set-branch | status | summary | sync | absorbgitdirs)
1069 command=$1
1071 -q|--quiet)
1072 GIT_QUIET=1
1074 -b|--branch)
1075 case "$2" in
1077 usage
1079 esac
1080 branch="$2"; shift
1082 --cached)
1083 cached="$1"
1086 break
1089 usage
1092 break
1094 esac
1095 shift
1096 done
1098 # No command word defaults to "status"
1099 if test -z "$command"
1100 then
1101 if test $# = 0
1102 then
1103 command=status
1104 else
1105 usage
1109 # "-b branch" is accepted only by "add" and "set-branch"
1110 if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
1111 then
1112 usage
1115 # "--cached" is accepted only by "status" and "summary"
1116 if test -n "$cached" && test "$command" != status && test "$command" != summary
1117 then
1118 usage
1121 "cmd_$(echo $command | sed -e s/-/_/g)" "$@"